import zero.json.Json;
import com.ibm.ws.xs.stats.client.routing.xsa.CatalogServerDesc;
import com.ibm.websphere.rainmaker.logging.MessageUtils;


// jmxpassword:, jmxuser:, port:2809, credgenClass:, host:b, name:a, keystorepassword:, credgenProps:
def onCreate() {
    def req = Json.decode(request.input[])

    def existing = getResource('domains', [name: req.name], ['id'])

    if (existing != null) {
        request.status = 201
        request.json.output = [error: true, msg: MessageUtils.message(user.lang[], 'XSW0140', [req.name])]
        request.view = 'JSON'
        render()
    } else {
        def domain = createResource('domains', [name: req.name, jmxuser: req.jmxuser, jmxpass: req.jmxpassword, customcredgenerator: req.credgenClass, 
                                                credgeneratorproperties: req.credgenProps, keystorepassword: req.keystorepassword], 1 )
        def catservers = [[name: req.host, listenerport: req.port, jmxport: 1099, clientport: 0]]

        if (req.keystore != "") {
            def keystore = getResource('keystores', [name: req.keystore], ['id'])

            if (keystore == null) {
                request.status = 201
                request.json.output = [error: true, msg: MessageUtils.message(user.lang[], 'XSW0141', [req.name])]
                request.view = 'JSON'
                render()
                return;
            }

            createResource('domainskeystores', [domainid: domain.id, keystoreid: keystore.id], 1)
        }
        
        
        //TODO: Code here drops discovered catservers into 'catservers'.

        def servobjs = []

        System.err.println("DOMAIN: " + domain.toString())

        catservers.each {
            existing = getResource('servers', [name: it.name], ['id'])

            if (existing != null) {
                it["id"] = existing.id
                updateResource('servers', it,  ["id", "name", "listenerport", "jmxport", "clientport"])
                servobjs.add(it)
            } else {
                servobjs.add(createResource( 'servers', it, 1 ))
            }
        
        }

        servobjs.each {
            createResource('domainsservers', [domainid: domain.id, serverid: it.id], 1)
        }

        request.status = 201
        request.json.output = [error: false, msg: "", domainid: domain.id]
        request.view = 'JSON'
        render()
    }
}    
