/* TODO: This should move to a xs.app.setup, so it is easier for us to not ship this. */
import com.ibm.websphere.rainmaker.logging.Output;
import com.ibm.websphere.rainmaker.logging.CleanStackTrace;
import groovy.rainmaker.constants.*;
import com.ibm.websphere.rainmaker.logging.MessageUtils;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.io.IOException;



def taskLogger;
def lang;

def setupClasspath() {
    def f = new File(config.dependencies.'ibm:xs.app'[] + "/.zero/private/resolved.properties")
    
    def lib = new File(config.dependencies.'ibm:xs.app'[] + "/../lib/ogclient.jar")
    if ( !lib.exists() ) {//WAS installation
       lib = new File(config.dependencies.'ibm:xs.app'[] + "/lib/ogclient.jar")
    }
    
    def fs = new FileInputStream(f.absolutePath)
    def p = new Properties()

    p.load(fs)

    if (!p["classpath.cli"].contains(lib.absolutePath)) {
        p["classpath.cli"] += System.getProperties().getProperty("path.separator") + lib.absolutePath
        
        def os = new FileOutputStream(f.absolutePath)

        p.store(os, "")
    }
}

def broadcastInfo(message) {
	Output.info(message);
	log(message);
}

def broadcastError(message) {
	Output.error(message);
	log(message);
}

def log(message) {
	taskLogger.append(getNow()+" :: "+message+"\n");
}

def getNow() {
	SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
	return formatter.format(Calendar.getInstance().getTime());
}

def onCliTask() {
	taskLoggerPath = config.dependencies.'ibm:xs.app'[] + "/logs/stopConsoleServer.log"
	lang = MessageUtils.getLanguageFromLocale(Locale.getDefault());
	taskLogger = new File(taskLoggerPath);

	if (taskLoggerPath.indexOf("\\") != -1) {
		taskLoggerPath = taskLoggerPath.replace("\\", "\\\\").replace("/", "\\\\");
	}
	
	Socket socket = null;
	try {
		socket = new Socket();
		SocketAddress address = new InetSocketAddress('localhost', config.https.port[].toInteger());
		socket.connect(address, 1000);
		broadcastError(MessageUtils.message(lang, 'XSW0165'));
	} catch (IOException e) {
		broadcastInfo(MessageUtils.message(lang, 'XSW0164'));	
	} finally {
		if (socket != null) {
			try {
				socket.close();
			} catch (Exception e){}
		}
	}
}
