/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package groovy.rainmaker.acl;

import com.ibm.websphere.acl.PermissionsACL;

logger.FINE { "Changing ownership of resources created by the deleted user (id: ${event.id[]})..." };

def adminID = event.session[].id;

//['templates', 'patterns', 'instances', 'scripts', 'part2s', 'fixes', 'groups', 'clouds'].each { type ->
['groups'].each { type ->
    logger.FINE { "Looking for ${type} owned by the user..." };

    def resources = getResources(type, [:], event.id[]);

    resources.each {
        it.ownerid = adminID;
        updateResource(type, it, ['ownerid']);

        //
        // groups don't have ACLs... they *are* ACLs (sort of)
        //
        if (type == 'groups')
            return;

        if (getAccessControl(type, it.id, adminID) != PermissionsACL.NONE)
            updateAccessControl(type, it.id, adminID, false, PermissionsACL.DELETE)

        else
            createAccessControl(type, it.id, adminID, false, PermissionsACL.DELETE)
    }
}

logger.FINE { "All resources were given to user '${event.session[].username}'." };

//logger.FINE { "Changing ownership of tasks created by the deleted user (id: ${event.id[]})..." };

//def tasks = getTasks([createduserid: event.id[]]);

//tasks.each { task ->
//    task.createduserid = adminID;
//    updateTask(task);
//}

//logger.FINE { "All tasks were given to user '${event.session[].username}'." };

logger.FINE { "Deleting all ACL entries for the deleted user (id: ${event.id[]})..." };

deleteAccessControls(event.id[]);

logger.FINE { 'All of the  ACL entries for the user were deleted.' };
