/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package groovy.rainmaker.appliance;
import com.ibm.bedrock.processmanager.ProcessManagerUtils;
import com.ibm.bedrock.BedrockUtils;

import groovy.rainmaker.constants.Action;
import groovy.rainmaker.constants.Constants;
import com.ibm.websphere.rainmaker.auditing.AuditDataHelper;


def updatePower(command) 
{
	def immediate = true;
	if (command.when == 'graceful'){
		immediate = false;
	}
	if(BedrockUtils.isBedrock()){
		if(immediate){
			AuditDataHelper.audit(Action.UPDATE, Constants.POWER, "Calling immediate power function without task", [mode: command.mode] );
			Thread.start {
				sleep(5000); 
				if('halt' == command.mode){ 
					ProcessManagerUtils.requestShutdown();
				}else if ('reboot' == command.mode){
					ProcessManagerUtils.requestReboot();
				}
			}
		}else{
			def instance = com.ibm.websphere.rainmaker.appliance.bedrock.PowerFactory.getInstance();
			if('halt' == command.mode){ 
				instance.shutdown();
			}else if ('reboot' == command.mode){
				instance.reboot();
			}
		}
		return true;
	}else{
		updatePowerDeprecated(command);
	}
}
def updatePowerDeprecated(command){
	
	
// DEFER GRACEFUL SHUTDOWN
// SINCE XSA is not porting task manager support.
//	if (command.when == 'graceful')
//		createShutdown(command.mode);
//	
//	else 
//	{
	    if (!command.delay)
	        command.delay = 5;
	    
		return executeApplianceRequest([
	        name: 'soma:do-action',
	        content: [:], 
	        children: [
	            [
	                name: 'Shutdown', 
	                content: [:], 
	                children: [
	                    [
	                        name: 'Mode', 
	                        content: command.mode
	                    ],
	                    [
	                        name: 'Delay', 
	                        content: command.delay
	                    ]
	                ]
	            ]
	        ]
	    ]);
//	}
}
