/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import zero.core.security.util.XOREncoder;
import zero.json.Json;
import com.ibm.websphere.objectgrid.security.SecurityConstants;
import com.ibm.websphere.users.Permissions;

def onPutCollection()
{
    if (!user.session[].permissions.contains(Permissions.APPLIANCE_ADMIN))
        return com.ibm.websphere.rest.RenderUtils.renderError(403, 'RM08008');

    def authenticationInput = null;

    try
    {
        authenticationInput = Json.decode(request.input[]);
    }

    catch (Throwable t)
    {
        return com.ibm.websphere.rest.RenderUtils.renderError(400, 'RM08002', t);
    }

    def overrideDefaultChanged = (authenticationInput.containsKey('overrideDefault') && authenticationInput.overrideDefault != zget(config.rainmaker.defaultPersistentZone[] + "/rainmaker/security/authentication/overrideDefault") || (authenticationInput.containsKey('value') && authenticationInput.value!="") || (authenticationInput.containsKey('verification') && authenticationInput.verification!="") );
    
    if (authenticationInput.containsKey('overrideDefault') && !authenticationInput.overrideDefault){
        	authenticationInput.secureTokenManagerType = SecurityConstants.SECURE_TOKEN_MANAGER_NONE_STRING;
        	authenticationInput.authenticationSecret = "XSA_APPLIANCE";
    }
    
    if(authenticationInput.containsKey('overrideDefault') && authenticationInput.overrideDefault && overrideDefaultChanged){
    	authenticationInput.secureTokenManagerType = SecurityConstants.NEW_SECURE_TOKEN_MANAGER_STRING;
    	
    	if(authenticationInput.containsKey('value')) {
    		def password = authenticationInput.value.trim();
    		def verification = authenticationInput.verification.trim();
    	                
    		if(password!="" || verification!="") {
    			if (!password.equals(verification)) return com.ibm.websphere.rest.RenderUtils.renderError(400, 'RM08006');
				authenticationInput.authenticationSecret = password.replaceAll('&amp;', '&').trim();
        	}
        }
    }	
	
    if(authenticationInput.containsKey('requireAuthentication')){
    	def requireAuth = authenticationInput.requireAuthentication;
    	    
    	if (requireAuth) {
    	    authenticationInput.credentialAuthentication = "Required";			 
		} else {
			authenticationInput.credentialAuthentication = "Supported";
		}
    }

     if (authenticationInput.containsKey('overrideDefault')){
             zput(config.rainmaker.defaultPersistentZone[] + "/rainmaker/security/authentication/overrideDefault" , authenticationInput.overrideDefault);
     }
     if (authenticationInput.containsKey('overrideDefault')){
             zput(config.rainmaker.defaultPersistentZone[] + "/rainmaker/security/authentication/requireAuthentication" , authenticationInput.requireAuthentication);
     }
                       
     com.ibm.ws.xsa.collectives.ssl.resources.Ssls.updateSsl(authenticationInput);
}

