/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.ws.xsa.snmp.exception.AddingDuplicateSNMPCommunityException;
import com.ibm.ws.xsa.snmp.CommunityOperations;
import zero.json.Json;

def onList()
{
	CommunityOperations commOps = CommunityOperations.getInstance();
	request.json.output = commOps.getSNMPCommunities(/*_args,*/ false);
	request.view = com.ibm.websphere.rest.RenderUtils.getRequestedView();
	render();
}

def onCreate()
{
	def newCommunity = Json.decode(request.input[]);	
	try {
		CommunityOperations commOps = CommunityOperations.getInstance();
		commOps.addSNMPCommunity(
				(String)newCommunity.name,
				// due to design meeting, we are only doing read-only permission v2c version until further notice
				//(String)newCommunity.permissions,
				"rocommunity",
				(String)newCommunity.network, 
				//(String)newCommunity.version, 
				"v2c", false);
		request.json.output = newCommunity;
		request.view = com.ibm.websphere.rest.RenderUtils.getRequestedView();
		render();
	} catch (AddingDuplicateSNMPCommunityException a) {
		// catch duplicate community
		return com.ibm.websphere.rest.RenderUtils.renderError(500, 'RM08087', a, [(String)newCommunity.name]);		
	} catch (Exception e) {
		return com.ibm.websphere.rest.RenderUtils.renderError(500, 'RM08088');
	}
}

def onDelete()
{
	try
	{
		//def success = deleteCommunity(request.params.communitiesId[]);
		//def success = RESTUtils.handleOnDelete(request.params.communitiesId[]);
		//System.out.println("communities.groovy onDelete() request.input: ${request.input[]}");
		//def communityToDelete = Json.decode(request.input[]);
		//String communitiyToDelete = Json.decode(request.params.communitiesId[]);

		CommunityOperations commOps = CommunityOperations.getInstance();
		def success = commOps.deleteSNMPCommunity(request.params.communitiesId[], false);
		
		if (!success)
			return renderError(404, 'RM08001');
	}
	
	catch (Throwable t)
	{
		return renderError(500, 'RM08005', t);
	}
}