/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.ws.xsa.iphosts.exception.AddingDuplicateIPHostMappingException;
import com.ibm.ws.xsa.iphosts.IPHostsOperations;
import zero.json.Json;

def onList()
{
	IPHostsOperations hostOps = IPHostsOperations.getInstance();
	request.json.output = hostOps.getIPHostMappings();
	request.view = com.ibm.websphere.rest.RenderUtils.getRequestedView();
	render();
}

def onCreate()
{
	def newMapping= Json.decode(request.input[]);	
	try {
		IPHostsOperations hostOps = IPHostsOperations.getInstance();
		hostOps.addIPHostMapping(
				(String)newMapping.address,
				(String)newMapping.hosts);
		request.json.output = newMapping;
		request.view = com.ibm.websphere.rest.RenderUtils.getRequestedView();
		render();
	} catch (AddingDuplicateIPHostMappingException a) {
		// catch duplicate mapping
		return com.ibm.websphere.rest.RenderUtils.renderError(500, 'RM08089', a, [(String)newMapping.address]);		
	} catch (Exception e) {
		return com.ibm.websphere.rest.RenderUtils.renderError(500, 'RM08003');
	}
}

def onDelete()
{
	try
	{
		IPHostsOperations hostOps = IPHostsOperations.getInstance();
		def success = hostOps.deleteIPHostMapping(request.params.iphostsId[]);
		
		if (!success)
			return com.ibm.websphere.rest.RenderUtils.renderError(404, 'RM08001');
	}
	
	catch (Throwable t)
	{
		return com.ibm.websphere.rest.RenderUtils.renderError(500, 'RM08005', t);
	}
}