/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import zero.core.security.util.XOREncoder;
import zero.json.Json;
import com.ibm.websphere.rest.RenderUtils;
import com.ibm.websphere.rest.RESTUtils;
import com.ibm.ws.xc10.snmp.rest.InvokeREST;


def onList()
{	
    def up = InvokeREST.isEnabled()
    request.view = RenderUtils.getRequestedView();
    request.json.output = up;
    render();
}

def onPutCollection()
{
    def jsonRequest = null;

    try
    {
        jsonRequest = Json.decode(request.input[]);
    }
    catch (Throwable t)
    {
        return renderError(400, 'RM08002', t);
    }
    
    InvokeREST.processPut(jsonRequest);
}

//def startSNMPprocess(port) {
//	System.out.println("snmp.groovy startSNMPprocess() entry");
//    if(port.equals("2282") || port.equals("2283")) {
//        logger.FINE { " Tried to start snmp on reserved port: " + port };
//                                                    
//        return false;                                                 
//    }                                                                
//                                           
//    def startProcessRC = execute("/usr/sbin/snmpd -x tcp:127.0.0.1:2283 -Lf w /drouter/local/snmpd.log -p /usr/share/snmp/snmpd.pid ${port}");
//    System.out.println("snmp.groovy  startSNMPprocess startProcessRC: " + startProcessRC);
//    sleep(500);  //Wait for agentx to start    
//                                               
//    def pids = checkSNMPprocess();   //If SNMP fails to start, the ProcessBuilder will normally still return 0, but the process
//                                     //will be missing...need to run ps to determine if it actually worked or not
//                                               
//    if(pids[0] == -1 || startProcessRC != 0) {
//        System.out.println("Failed to start snmp at port " + port );
//        logger.FINE { "Failed to start snmp at port " + port };
//        return false;
//    } 
//
//
//    logger.FINE { "Started CB snmp agent on port " + port };
//          
//    def startSubAgentRC = execute("/usr/sbin/cbSubAgent -x tcp:127.0.0.1:2283");
//
//    if(startSubAgentRC != 0) {
//        logger.FINE { "Failed to start snmp sub: CB-specific function will not be available" };
//    }
//
//    logger.FINE { "Started CB snmp subagent" };
// 
//    storage.rainmaker.snmp.enabled = true;
//    storage.rainmaker.snmp.port = port;
// 
//    System.out.println("snmp.groovy startSNMPprocess() exit");
//    return true;
//    
//}
//
//def killSNMPprocess(pid) {
//	//PPM kill was /usr/sbin/killer
//	System.out.println("snmp.groovy killSNMPprocess() entry");
//    execute("/bin/kill ${pid}");
//    System.out.println("snmp.groovy killSNMPprocess() exit");
//    return true;
//}
//
//def checkSNMPprocess( ) {
//	System.out.println("snmp.groovy checkSNMPprocess() entry");
//    def pids = [-1, -1];
//
//    new File('/proc').list().toList().each() { procEntry ->        
//        if(procEntry.isNumber() ) {        	
//            def procDir = new File('/proc/' + procEntry + '/cmdline');
//            //System.out.println("PPM snmp.groovy checkSNMPprocess, searching for file: /proc/"  + procEntry + "/cmdline");
//            if((pids[0] == -1 || pids[1] == -1) && procDir.exists() ) {
//                procDir.eachLine() { line ->
//                    if(line.contains('snmpd')) {
//                        pids[0] = procEntry;
//                    }
//                    else if( line.contains('cbSubAgent') ) {
//                        pids[1] = procEntry;
//                    }
//                }    
//            }
//        }
//    }
//    System.out.println("pids[0],[1]: " + pids[0] + ", " + pids[1]);
//    System.out.println("snmp.groovy checkSNMPprocess() exit");
//    return pids;
//}