/*
  Licensed Materials - Property of IBM
  IBM WebSphere CloudBurst Appliance (9235-72X)
  Copyright IBM Corporation 2009. All Rights Reserved.
  US Government Users Restricted Rights - Use, duplication or disclosure
  restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.ws.xsa.snmp.exception.AddingDuplicateSubscriberException;
import com.ibm.ws.xsa.snmp.CommunityOperations;
import zero.json.Json;

def onList()
{
	CommunityOperations commOps = CommunityOperations.getInstance();
	request.json.output = commOps.getSNMPTrapSubscribers();
	request.view = com.ibm.websphere.rest.RenderUtils.getRequestedView();
	render();
}

def onCreate()
{
	def newSubscriber = Json.decode(request.input[]);	
	try {
		CommunityOperations commOps = CommunityOperations.getInstance();
		commOps.addSNMPTrapSubscribers(
				(String)newSubscriber.Host,				
				(String)newSubscriber.Port,
				(String)newSubscriber.Community); 
				//(String)newSubscriber.Version);
		request.json.output = newSubscriber;
		request.view = com.ibm.websphere.rest.RenderUtils.getRequestedView();
		render();
	} catch (AddingDuplicateSubscriberException a) {
		// catch duplicate subscriber
		return com.ibm.websphere.rest.RenderUtils.renderError(500, 'RM08090', a, [(String)newSubscriber.Host]);		
	} catch (Exception e) {
		return com.ibm.websphere.rest.RenderUtils.renderError(500, 'RM08088');
	}
}

def onDelete()
{
	try {
		CommunityOperations commOps = CommunityOperations.getInstance();
		def success = commOps.deleteSNMPTrapSubscribers(request.params.trapSubscribersId[]);
		
		if (!success)
			return renderError(404, 'RM08001');
	} catch (Throwable t) {
		return renderError(500, 'RM08005', t);
	}
}