/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.zip.ZipFile;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import java.io.*;
import java.util.zip.*;

import com.ibm.websphere.rainmaker.auditing.*;
import com.ibm.websphere.rainmaker.logging.*;
import com.ibm.websphere.rainmaker.logging.CleanStackTrace;
import com.ibm.websphere.rainmaker.auditing.AuditDataHelper;


def onList()
{
//	def keystoreConfig = config.https.sslconfig[];
//	def keystore = keystoreConfig.keyStore;
//	def alias = "websphere rainmaker";
//	def passwordEncoded = keystoreConfig.keyStorePassword;
//	def password = XOREncoder.decode(passwordEncoded);

	
//	def filter = [:];
//    zlist('/request/params').each {
//    	def parts = it.tokenize('/');
//    	if(parts.size()>2) {
//    		def name = parts[2];
//            filter[name] = zget(it);	
//    	}        
//    }

	def tempDir = config.rainmaker.tempDir[];
	if(tempDir == null)
	{
		tempDir = config.rainmaker.disk.root[]+"/tmp";
	}
	

	// Save to a tempdir and Sign it
	String auditLog = "";
	String auditSig = "";
	File targetDir = new File(tempDir + '/' + System.currentTimeMillis());
	targetDir.mkdirs();
	
	// Text Mode
	boolean self = true;
	if(zcontains("/request/params/proxyApp") ){
		self = false;
		try{
    		context = new zero.core.context.Context();
    		def masterApp = new File(config.root[], "../"+ "rainmaker.app");
    		zero.core.config.ConfigLoader.initialize(masterApp.absolutePath, context);
		}catch (Throwable t){
			context = null;
			logger.SEVERE { CleanStackTrace.cleanStackTrace(t) }
		}
	}
	
	auditLog = targetDir.getAbsolutePath() + "/audit.log";
	
	if(self){
		//AuditDataHelper.saveAuditLog(AuditDataHelper.getAuditData([:]), new FileOutputStream(auditLog));
		
		// For performance issue, did the following changes.
		File dir = new File(AuditFileHandler.getHandler().getHomedir());
		def files = dir.listFiles();
		ArrayList<File> filteredFiles = new ArrayList<File>(); 
		for(int i = 0; i < files.size(); i++) {
			if(AuditFileHandler.getHandler().isValidLogFile(files[i]))
			{
				filteredFiles.add(files[i]);
			}
		}
        
        	Collections.sort(filteredFiles);
        
		File current = null;
		for(int i = 0; i < filteredFiles.size(); i++)
		{
			if(filteredFiles.get(i).getAbsolutePath().endsWith(AuditLogger.AUDIT_PREFIX
				+LogFileConstant.STRING_EXT_NAME))
			{
				current = filteredFiles.remove(i);
			}
		}
		if(current != null)
		{
			filteredFiles.add(current);
		}

		_mergeFiles(filteredFiles, auditLog);
	}else{
		def auditDirectory=null;
		if(context!=null){
			auditDirectory = context.zget("/config/rainmaker/logsDir") + "/audit";
		}else{ // guess
			auditDirectory = defaultDiskLocation + "/logs/audit";
		}
		AuditDataHelper.saveAuditLog(AuditDataHelper.getAuditDataProxy(auditDirectory, [:]), new FileOutputStream(auditLog));
	}

	// Sign the audit log
	//AuditDataHelper.signAuditLog(keystore, alias, password, auditLog);
	
	// Create a zip package.
	request.headers.out.'Content-Type' = 'application/zip';
    request.headers.out.'Content-Disposition' = 'inline; filename=audit.zip';
    // set these headers to avoid caching issues with IE over SSL
    request.headers.out.Expires = '0';
    request.headers.out.Pragma = 'cache';
    request.headers.out.'Cache-Control' = 'private';

	
	int BUFFER = 2048;
	OutputStream os = request.outputStream[];
	ZipOutputStream out = new ZipOutputStream(new BufferedOutputStream(os, BUFFER));
	def files = [];
	files.add(auditLog);
	//files.add(auditSig);
	
	for(String f : files) {
		FileInputStream fis = new FileInputStream(f);
		BufferedInputStream origin = new BufferedInputStream(fis, BUFFER);
		ZipEntry zipEntry = new ZipEntry(f.substring(f.lastIndexOf(File.separator)+1));
		byte[] data = new byte[BUFFER];
		int c;
		out.putNextEntry(zipEntry);
		while((c = origin.read(data, 0, BUFFER)) != -1) {
			out.write(data, 0, c);
		}
		origin.close();
	}
	
	out.close();
	
}


def _mergeFiles(fileList, target)
{
    try
	{
		BufferedWriter bw = new BufferedWriter(new FileWriter(target));
		for(File file : fileList)
		{
			BufferedReader reader = null;
			if(file.getName().endsWith(".gz"))
			{
				GZIPInputStream gzis = new GZIPInputStream(new FileInputStream(file));
        			InputStreamReader isr = new InputStreamReader(gzis);
        			reader = new BufferedReader(isr);
			}
			else
			{
				reader = new BufferedReader(new FileReader(file));
			}
			char[] cbuf = new char[1024];
			int len = -1;
			while((len = reader.read(cbuf)) != -1)
			{
				bw.write(cbuf, 0, len);
				bw.flush();
			}
			reader.close();
		}
		bw.close();
	}
	catch(Exception e)
	{
	}
}
