/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package groovy.rainmaker.ui;

import com.ibm.websphere.acl.PermissionsACL;
import groovy.rainmaker.constants.Status;
import com.ibm.websphere.users.Permissions;
import com.ibm.websphere.rainmaker.logging.MessageUtils;

def _getFileUploadDefaultMessage(name)
{
    def type = request.params.render.resourceType[];
    def resource = null;
    if (name.equals('scriptArchive.zip'))
    {
    	def id = request.params.render.resourceID[].toInteger();
        def destDir = null;
        
        if(type.equals('scripts'))
        {
        	resource = getScript(id)
        	if(resource?.currenteditionid)
        		destDir = getScriptStorage(resource.currenteditionid);
        }
        else
        {
        	resource = getFixe(id);
        	destDir = getFixeStorage(id);        	
        }
        
        if (!destDir?.exists())
            return MessageUtils.message(user.lang[], 'RM10241', []);
        def fileList = destDir.listFiles()
        if(fileList.size() < 1)
            return MessageUtils.message(user.lang[], 'RM10241', []);
        def file = fileList[0];
        return "${MessageUtils.message(user.lang[], 'RM10242', [file.name])} <img src='/images/download-icon.gif' class='icon-image' style='vertical-align: middle; padding-left: 15px;' alt=\"${MessageUtils.message(user.lang[], 'RM10048', [])}\"/> <a href='/resources/${type}/${resource.id}/scriptArchive.zip'>${MessageUtils.message(user.lang[], 'RM10048', [])}</a>";
    }
    
    return '';
}

def renderFileUpload(name, resource)
{
    def type = request.params.render.resourceType[];
    def id = request.params.render.resourceID[];
    
    def defaultMessage = _getFileUploadDefaultMessage(name);
    
    if (!canUpdate(type, id, user.session[].id) || (resource.currentstatus == Status.PUBLISHED))
        return "<span class='default'>${defaultMessage}</span>";
    
    request.params.render.fileID = 'archive';
    request.params.render.formURI = "/resources/${type}/${id}/${name}";
    request.params.render.formNLS = MessageUtils.message(user.lang[], 'RM10142', []);
    request.params.render.submitNLS = MessageUtils.message(user.lang[], 'RM10133', []);
    
    def content = invokeTemplate('widgets/styledFileUpload.gt');
    
    //
    // HACK: something about template file encoding is causing non-printable 
    //       characters to appear at the beginning of the content
    //
    def htmlStart = content.indexOf('<');
    content = htmlStart >= 0 ? content.substring(htmlStart) : '';
    
    return content + "<br/><span id='archiveFileUpload-results' class='default'>${defaultMessage}</span>";
}
