/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/
//
// BaseWidget provides the basic display and identification mechanisms for all custom widgets.
//
dojo.provide("javascript.widgets.BaseWidget");

dojo.declare("javascript.widgets.BaseWidget", dijit._Templated, {

	_initialize: true,

    hide: function() {
    	Bedrock.hide(this.element);
        //this.element.style.display = 'none';
    },
    
    initialize: function(_parent, properties) {
        console.log("base widget constructor called", arguments);
        this.parent = _parent;
        
        var parentDOM = _parent.element || _parent;
        
        //
        // IDs are generated by tacking on the given value to the parent's ID. 
        // this ensures we have unique IDs throughout the DOM.
        //
        properties['id'] = parentDOM.id + '-' + properties['id'];
        
        //this.element = new Element('div', properties);
        this.element = document.createElement('div');
        // JMB, need to add the properites
        for ( prop in properties ) {
        	console.log("prop is " + prop + " and value is " + properties[prop]);
            if ( prop == 'class' ) {
            	dojo.addClass( this.element, properties[prop]);
            }
            else {
				this.element.setAttribute(prop, properties[prop]);
			}
			
        }
        parentDOM.appendChild(this.element);
    },
    
    constructor: function() {
    	console.log("BaseWidget ctr");
    },
    
    show: function() { 
    	Bedrock.show(this.element, {'display': 'block'} );
    }
    
});
