/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/
//
// PropertyPanel can display information about a resource in a table, with each mutable 
// field represented by an HTML form widget appropriate for its type. Immutable fields 
// are displayed as plain text. Fields that represent relationships to other resources 
// are displayed as hyperlinks to pages with details on those resources.
//

dojo.provide('javascript.widgets.PropertyPanel');
dojo.require('javascript.widgets.DetailPanel');
// documentation suggests to include this..
dojo.require("dijit._base.focus");

dojo.declare('javascript.widgets.PropertyPanel', javascript.widgets.DetailPanel, {   
    
    addInPlaceEditor: function(ipe) {
        this._ipes.push(ipe);
    },
    
    deleteInPlaceEditors: function() {
        this._ipes.each(function(ipe) {
            ipe.destroy();
        });
        this._ipes = [];
    },

    _getScrollableElement: function() {
        return dojo.byId('dashboard-properties');
    },

    initialize: function(parent, name, options) {
		console.log("property-panel initialize called");
    	this.inherited(arguments, [parent, name, 'application/rainmaker+properties', options] );
        this._ipes = [];
    },
    
    constructor: function(parent, name, options) {
	// initialize is called by DetailPanel
	//this.initialize(parent, name, options);
    },
    
    selectResource: function(uri, id, fields, dontShowAfter) {
    	this.inherited(arguments);
   } 
});
