//
// ShutdownModalDialog is a simple confirmation dialog that disables the rest of the browser until 
// the user makes a selection. It is centered within the screen and uses the Scriptaculous 
// 'appear' effect to show the disabled screen ('overlay') and dialog window.
//

dojo.provide("javascript.widgets.ShutdownModalDialog");
dojo.require("dijit.form.RadioButton");
dojo.require("dijit.form.CheckBox");
dojo.require("javascript.widgets.ModalDialog");

dojo.declare("javascript.widgets.ShutdownModalDialog", javascript.widgets.ModalDialog, {
   
	 cleanup: function(id) {
        this.inherited(arguments);

        // remove the form data we added to the dialog
        var extensionRows = dojo.query('.' + id + '-dialog-extension-row');
        dojo.forEach(extensionRows, function(row){
        	row.parentNode.removeChild(row);
        });
    },
	
	setRadio: function(optionText1, optionText2) {
		// create table to house radio buttons:
		var submitRow = dojo.byId(this.id + '-submit-row');
	    var tableBody = submitRow.parentNode;

		var extensionRow = dojo.create('tr');
		dojo.addClass(extensionRow, this.id + '-dialog-extension-row');
		dojo.place(extensionRow, submitRow, "before");

	    var extensionColumn = dojo.create('td', null , extensionRow);
	    
		var form  = dojo.create('form',  { 'id': this.id + '-form', 	'onsubmit': this.onSubmit } , extensionColumn);

	    var radioTable = dojo.create('table',  null , form);
	    
        // accessibility since table is purely for layout 
        radioTable.setAttribute ("role", "presentation" );
	    
	    
	    
        var radioTableBody = dojo.create('tbody',  null , radioTable);
        
	    //first row
        var radioRowOne = dojo.create('tr',  null , radioTableBody);
	    var radioTDOneColOne = dojo.create('td',  null , radioRowOne);
	    dojo.style(radioTDOneColOne, 'paddingBottom', '10px');

	    if(dijit.byId('radiograceful')){
	    	dijit.byId('radiograceful').destroy();
	    }
	    
	    var radioGraceful = new dijit.form.RadioButton({
            value: 'graceful',
            name: 'whenToShutdown',
            'id': 'radiograceful',
            checked : true
        });
        radioTDOneColOne.appendChild(radioGraceful.domNode);
        radioGraceful.startup();

	    var radioTDOneColTwo = dojo.create('td',  { innerHTML : "<span class=\"default\" style=\"margin-left: 5px;\">" + optionText1 + "</span>" } , radioRowOne);
	    dojo.style(radioTDOneColTwo, 'paddingBottom', '10px');
	    
	    // next row
        var radioRowTwo = dojo.create('tr',  null , radioTableBody);
	    radioTDOneColOne = dojo.create('td',  null , radioRowTwo);

	    if(dijit.byId('radioimmediate')){
	    	dijit.byId('radioimmediate').destroy();
	    }
	    
		var radioImmediate = new dijit.form.RadioButton({
            value: 'immediate',
            name: 'whenToShutdown',
            'id': 'radioimmediate'
        });
		radioTDOneColOne.appendChild(radioImmediate.domNode);
		radioImmediate.startup();
       	
		var radioColOption2 = dojo.create('td',  { innerHTML: "<span class=\"default\" style=\"margin-left: 5px;\">" + optionText2 + "</span>" } , radioRowTwo);

    }
});