/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("javascript.widgets.XSASingleMessage");

dojo.require("idx.oneui.messaging.SingleMessage");

dojo.declare("javascript.widgets.XSASingleMessage", [idx.oneui.messaging.SingleMessage],{
	
    /**
	 * Whether to show the title link.  This is a destructive setting. Once showLink has been set to false, it cannot be set back to true
	 * @type Boolean
	 * @default true
	 */
	showLink: true,
	
	postCreate: function(){
		this.inherited(arguments);
		
		//Get rid of the More Details link
		dojo.destroy(this.viewDetailsNode);
	},	
	
	_setShowLinkAttr: function(/*Boolean*/ show){
		this._set("showLink", show);
		dojo.toggleClass(this.focusNode, "idxMessageContentNoLink", !this.showLink);
		dojo.toggleClass(this.focusNode, "idxMessageContent", this.showLink);
		dojo.toggleClass(this.titleNode, "noLink", !this.showLink);
		dojo.toggleClass(this.iconNode, "noLink", !this.showLink);
		if(!show) {
			dojo.removeAttr(this.focusNode, "title");
			this._onClick = function(e){/*no-op*/};
		}
	},
	
	_setCollapsedAttr: function(value){
		this.inherited(arguments);
		if(!this.showLink) dojo.removeAttr(this.focusNode, "title");			
	},
	
	_onClick: function(e){
		this.inherited(arguments);
		this._resizeBorderContainer();
	},
	
	_onClose: function(e){
		this.inherited(arguments);
		this._resizeBorderContainer();
	},
	
	_resizeBorderContainer: function(){
		//Resize border container
		var bc = dijit.byId("message_center_border_container");
		if(bc) bc.resize();
	}
});