/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package groovy.rainmaker.users;

import groovy.rainmaker.constants.*;
import com.ibm.websphere.rainmaker.logging.CleanStackTrace;
import com.ibm.websphere.rainmaker.auditing.AuditDataHelper;

class TimerStatics{
	static def timer = new Timer();
	
}

def _setUserActivity(id, active)
{
    def status = active ? Status.LOGGED_IN : Status.LOGGED_OUT;
    def msg = active ? 'RM02011' : 'RM02012';
    updateUser([id: id, currentstatus: status, currentmessage: msg]);
}

def session = user.session[];

if (session == null)
    return;

_setUserActivity(session.id, true);

logger.FINEST { "Starting timer to revert current status of user ${session.username}." };

def timeout = 5 * 60 * 1000;  // 5 minutes

def task = TimerStatics.timer.runAfter(timeout) {
    try
    {
        logger.FINEST { "Session has timed out for user ${session.username}, updating current status value." };
        _setUserActivity("${session.id}".toInteger(), false);

        // Session timed out, user became inactive, audit this event
        AuditDataHelper.audit(Action.TIMEOUT, Constants.SESSION,
       		"Session has timed out for user ${session.username}.", [:]);
    }
    
    catch (Throwable t)
    {
        logger.WARNING { CleanStackTrace.cleanStackTrace(t) };
    }
}

def gcKey = "/tmp/sessions/${session.id}/timer";

def previousTask = zget(gcKey);
previousTask?.cancel();

zput(gcKey, task);
