dojo.provide("xsa.monitor.widgets.dashboard.ChartContainer");

dojo.require("dojo.string");
dojo.require("dojo.data.ItemFileReadStore");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.AccordionContainer");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dijit.form.Select");
dojo.require("dijit.form.NumberTextBox");
dojo.require("dijit.form.HorizontalSlider");
dojo.require("dijit.form.HorizontalRule");
dojo.require("dijit.form.HorizontalRuleLabels");
dojo.require("dojo.i18n");
dojo.require("xsa.monitor.widgets.dashboard.DataPresentation");
dojo.requireLocalization("xsa.monitor.widgets.dashboard", "ChartContainer");

dojo.declare("xsa.monitor.widgets.dashboard.ChartContainer", [dijit._Widget, dijit._Templated],{
	// summary:
	//		This widget is a composite widget representing the right pane of the Custom Report

	// templateString: String
	//		The string to use for the template of this widget.
	templateString: '<div>'+
				'<div dojoType="dijit.layout.BorderContainer" design="headline" dojoAttachPoint="_borderContainer" gutters="false">' +
					'<div dojoType="dijit.layout.BorderContainer" design="headline" region="center" splitter="true" gutters="false">' +
						'<div dojoType="dijit.layout.ContentPane" region="top"  splitter="false" style="height: 2em; background-color: #FFFFFF;">' + 
                            '<label class="default-with-margin">Time range:</label>' +
							'<select dojoAttachPoint="timeRangeNode" dojoType="dijit.form.Select" dojoAttachEvent="onChange:_setTimeRangeAttr">'+
								'<option value="1hr" selected="selected">${_currentHour}</option>'+
								'<option value="1day">${_currentDay}</option>'+
								'<option value="1wk">${_currentWeek}</option>'+
								'<option value="1mon">${_currentMonth}</option>'+
							'</select>'+
						'</div>' +
						'<div dojoType="dijit.layout.ContentPane" region="center"  splitter="false" style="background-color: #FFFFFF;">' +
							'<div dojoType="dijit.layout.AccordionContainer" region="center" splitter="true" dojoAttachPoint="_accordion">' +
								'<div dojoType="dijit.layout.ContentPane" title="${_chartPaneTitle}">' +
									'<table cellpadding="0" cellspacing="3" border="0" class="dojoxLegendText">'+
										'<tr>'+
											'<td>'+
												'<span style="cursor:move"><div dojoAttachPoint="chartNode" style="width: 800px; height: 500px;" dojoAttachEvent="onmousedown:_onMouseDown, onmouseup:_onMouseUp, onmousemove:_onMouseMove"></div></span>'+
											'</td>'+
											'<td>'+
												'<div dojoAttachPoint="legendNode">${_legendText}</div>'+
											'</td>'+
										'</tr>'+
									'</table>'+
									'<center>' +
										'<div class="pad"><br>${_chartZoomLevel}</div>'+
										'<div align="center" dojoAttachPoint="zoomXSlider" dojoAttachEvent="onChange:_zoomXEvent" dojoType="dijit.form.HorizontalSlider" '+
												'value="1" minimum="1" maximum="10" discreteValues="10" showButtons="false"'+
												'style="width: 600px;">'+
												'<div dojoType="dijit.form.HorizontalRule" container="bottomDecoration" count="10" style="height:3px;"></div>'+
												'<div dojoType="dijit.form.HorizontalRuleLabels" container="bottomDecoration" minimum="1" maximum="10" count="10"'+
													'style="height:1.2em;font-size:60%;color:gray;"></div>'+
										'</div>'+
										'<div class="pad"><br>${_chartPanPosition}</div>'+
										'<div align="center" dojoAttachPoint="offsetXSlider" dojoAttachEvent="onChange:_offsetXEvent" dojoType="dijit.form.HorizontalSlider" '+
												'value="1" minimum="0" maximum="1000" discreteValues="1001" showButtons="false"'+
												'style="width: 600px;">'+
												'<div dojoType="dijit.form.HorizontalRule" container="bottomDecoration" count="11" style="height:3px;"></div>'+
												'<div dojoType="dijit.form.HorizontalRuleLabels" container="bottomDecoration" minimum="0" maximum="1" count="11"'+
													'style="height:1.2em;font-size:60%;color:gray;"></div>'+
										'</div>'+
									'</center>'+
								"</div>" +
								'<div dojoType="dijit.layout.ContentPane" title="${_gridPaneTitle}" dojoAttachPoint="_gridView">' +
									'<div dojoAttachPoint="gridNode" style="width: 100%; height: 100%"></div>' +
								"</div>" +
							"</div>" +
						"</div>" +
					"</div>" +
					'<div dojoType="dijit.layout.ContentPane" region="bottom" splitter="true" style="height: 5em;">' +
						'<br>' +
						'<center>' +
							'<div role="document">' +
								'<table cellpadding="0" dojoAttachPoint="series" cellspacing="0" border="1" rules="none">'+
									'<tr>'+
										'<th>${_seriesIDHeader}</th>'+
										'<th>${_seriesNameHeader}</th>'+
										/* Disabled as per Pat
										'<th>${_seriesCurrentHeader}</th>'+
										'<th>${_seriesMinHeader}</th>'+
										'<th>${_seriesMaxHeader}</th>'+
										*/
										'<th>${_seriesScalerHeader}</th>'+
									'</tr>'+
								'</table>'+
							'</div>' +
						'</center>'+
					'</div>' +	//CenterPane
				'</div>' +  //BC
			'</div>',

	// widgetsInTemplate: Boolean
	//		If true, the template as widgets in it.
	widgetsInTemplate: true,

	_zoomX: 1,
	_offsetX: 0,
	_axisOffset: 0,
	_timeout: null,
	_markers:
		[	"m-1,0 c0,-1.3 2,-1.3 2,0 m-2,0 c0,1.3 2,1.3 2,0", // draw a circle? seems to mean: move (-1,0) (to the left); curve ((0,-1.3),(2,-1.3),(2,0)) (bottom hemicircle); move(-2,0) (back to left); curve ((0,1.3),(2,1.3),(2,0)) (top hemicircle);
			"m-1.2,0 c0,-1.56 2.4,-1.56 2.4,0 m-2.4,0 c0,1.56 2.4,1.56 2.4,0",
			"m-1.4,0 c0,-1.82 2.8,-1.82 2.8,0 m-2.8,0 c0,1.82 2.8,1.82 2.8,0",
			"m-1.6,0 c0,-2.08 3.2,-2.08 3.2,0 m-3.2,0 c0,2.08 3.2,2.08 3.2,0",
			"m-1.8,0 c0,-2.34 3.6,-2.34 3.6,0 m-3.6,0 c0,2.34 3.6,2.34 3.6,0",
			"m-2,0 c0,-2.6 4,-2.6 4,0 m-4,0 c0,2.6 4,2.6 4,0",
			"m-2.2,0 c0,-2.86 4.4,-2.86 4.4,0 m-4.4,0 c0,2.86 4.4,2.86 4.4,0",
			"m-2.4,0 c0,-3.12 4.8,-3.12 4.8,0 m-4.8,0 c0,3.12 4.8,3.12 4.8,0",
			"m-2.6,0 c0,-3.38 5.2,-3.38 5.2,0 m-5.2,0 c0,3.38 5.2,3.38 5.2,0",
			"m-2.8,0 c0,-3.64 5.6,-3.64 5.6,0 m-5.6,0 c0,3.64 5.6,3.64 5.6,0",
			"m-3,0 c0,-4 6,-4 6,0 m-6,0 c0,4 6,4 6,0"
		],

	_update: function(){
		// summary:
		//		Convert zoon/pan values to axis values and update the chart
		var bounds = this.dataPres.getChartWidget().axes["independent"].getScaler().bounds;
		// save _axisOffset so that the axis can be refreshed without redoing the calculations
		this._axisOffset = (this._offsetX / 1000) * (bounds.upper - bounds.lower) * (this._zoomX - 1) / this._zoomX;
		this.dataPres.setPreparedStore();
	},

	_zoomXEvent: function(value){
		// summary:
		//		onChange handler for the zoom slider
		this._zoomX = value;
		this.zoomXValue.innerHTML = value; // update the zoom label text
		this._update();
	},

	_offsetXEvent: function(value){
		// summary:
		//		onChange handler for the panning slider
		this._offsetX = value;
		this.offsetXValue.innerHTML = Math.round(value/10) + "%"; // update the panning label text
		this._update();
	},

	_dragInitialization: null,
	_onMouseDown: function(e){
		// summary:
		//		Called when the mouse button is pressed over the chart area
		if(this._zoomX == 1 || !this.dataPres.getChartWidget()){ return; } // zoom=1 means that panning can't happen
		this._dragInitialization = { startX: e.clientX, offsetX: this._offsetX };
		dojo.stopEvent(e);
	},
	_onMouseUp: function(e){
		// summary:
		//		Called when the mouse button is released over the chart area
		if(this._dragInitialization){
			this._dragInitialization = null; // signal dragging has ended
			dojo.stopEvent(e);
		}
	},
	_onMouseMove: function(e){
		// summary:
		//		Called when the mouse moves across the chart area
		if(this._dragInitialization){ // if dragging...
			var mousePixels = e.clientX - this._dragInitialization.startX,
				chartPixelWidth = this.dataPres.getChartWidget().axes["independent"].getScaler().bounds.span,
				deltaOffsetX = Math.round(1000 * mousePixels / (this._zoomX - 1) / chartPixelWidth);
			// change the slider value which will eventually call _offsetXEvent(value)
			this.offsetXSlider.attr('value', Math.min(1000, Math.max(0, this._dragInitialization.offsetX - deltaOffsetX)));
			dojo.stopEvent(e);
		}
	},

	addMetric: function(seriesType, seriesId, metricTypeId, str, scalar){
		// summary:
		//		Add a new series to an existing chart, called from the left side Tree widget.
		// seriesType, seriesId, metricTypeId:
		//		See DataPresentation for a description of these values.
		// str:
		//		Text displayed in the Tree node selected to create the series
		// scalar:
		//		The Y zoom (optional, default = 1)
		scalar = scalar? scalar : 1.0;
		if(!this.dataPres.url){
			this.dataPres.url = this.url;
		}
		this.dataPres.addMetric(seriesType, seriesId, metricTypeId, scalar);
		
		var tr = this.series.insertRow(-1);
		var nameW = dojo.create("td", {innerHTML: '<input readOnly dojoType="dijit.form.TextBox" style="overflow:visible;" value="'+seriesId+'">'}, tr);
		var metricW = dojo.create("td", {innerHTML: '<input readOnly dojoType="dijit.form.TextBox" style="overflow:visible;" value="'+str+'">'}, tr);

		// Add a tooltip with the stat name value to work around truncation in
		// some of the more verbose languages. 
		new dijit.Tooltip({
							  connectId: [metricW],
							  label: str
						  });

		new dijit.Tooltip({
							  connectId: [nameW],
							  label: seriesId
						  });

		// The below are disabled for now as per Pat.  To re-enable, uncomment below and in template.
		//dojo.create("td", {innerHTML: '<input readOnly dojoType="dijit.form.NumberTextBox" style="width:5em;" value="0">'}, tr);
		//dojo.create("td", {innerHTML: '<input readOnly dojoType="dijit.form.NumberTextBox" style="width:5em;" value="0">'}, tr);
		//dojo.create("td", {innerHTML: '<input readOnly dojoType="dijit.form.NumberTextBox" style="width:5em;" value="0">'}, tr);
		dojo.create("td", {innerHTML: '<input dojoType="dijit.form.NumberTextBox" style="width:6em;" value="1.0">'}, tr);
		
		dojo.parser.parse(tr);
		var scalarBox = dijit.byNode(tr.lastChild.firstChild); // the changeable Y zoom textbox
		// when ENTER is pressed in the series table, then update the Y zoom of the chart
		this.connect(scalarBox.domNode, "onkeypress", function(evt){
			// Link up a listener so that if enter is pressed in the box, it fakes an onBlur
			// and triggers onChange.
			if(evt && evt.charOrCode == dojo.keys.ENTER){
				scalarBox._onBlur();
			}
		});
		scalarBox.onChange = dojo.hitch(this,
			function(scalar){
				this.dataPres.addMetric(seriesType, seriesId, metricTypeId, scalar);
			}
		);
	},

	_setTimeRangeAttr: function(newValue){
        this.dataPres._setTimeRangeAttr(newValue);
	},

	constructor: function(){
		 // summary:
		 //		over-ride of constructor to attach in the basic NLS properties that are used in the template.

		 // Attach in all the required messages that will be substituted into the template.
		 this._messages = dojo.i18n.getLocalization("xsa.monitor.widgets.dashboard", "ChartContainer");
		 dojo.mixin(this, this._messages);

		 // Sub in some attach points into the proper location in the translated text.
		 // Use single quotes in the text, as dojo escapes double quotes in the substituted text.
		 this._chartZoomLevel = dojo.string.substitute(this._chartZoomLevel, {0: "<span dojoAttachPoint='zoomXValue'>1</span>"});
		 this._chartPanPosition = dojo.string.substitute(this._chartPanPosition, {0: "<span dojoAttachPoint='offsetXValue'>0</span>"});
	},

	destroy: function(){
		// summary:
		//		Clean up DataPresentation as well
		this.dataPres.destroy();
		this.inherited(arguments);
	},

	resize: function(dim){
		// summary:
		//		Resize over-ride to allow calling of child widget resize so that
		//		the widget scales properly in a container.
		// dim:
		//		The dimensions object to process.
		if(dim){
			dojo.contentBox(this.domNode, dim);
		}

		var myDims = dojo.contentBox(this.domNode);
		
		// Internal function usage, may not port (but unlikely to change);
		// Remove any internal padding/margins and use that to set the size of the
		// contained border container.
		var pads = dojo._getPadBorderExtents(this.domNode);
		var margins = dojo._getMarginExtents(this.domNode);
		myDims.h -= (pads.h + margins.h);
		myDims.w -= (pads.w + margins.w);
		this._borderContainer.resize(myDims);

		this.inherited(arguments);
	},

	_isA11y: function(){
		// summary:
		//		A function for checking that a11y mode is enabled and selecting the
		//		right view for the chart.
		// tags:
		//		private
		return dojo.hasClass(dojo.body(), "dijit_a11y");
	},
	
	postCreate: function(){
		this.inherited(arguments);
		var _this = this;
		// create a DataPresentation subclass so that the zoom/pan can be updated when an auto-refresh occurs
		var myDataPres = dojo.declare(xsa.monitor.widgets.dashboard.DataPresentation, {
			_updateMarkers: dojo.hitch(_this,function(){
				dojo.forEach(
					this.dataPres.getChartWidget().series,
					dojo.hitch(this,
						function(s){
							// grow the markers as you zoom in
							s.marker = this._markers[this._zoomX - 1];
						}
					)
				);
			}),

			_updateAxis: dojo.hitch(_this,function(){
				this.dataPres.getChartWidget().setAxisWindow("independent", this._zoomX, this._axisOffset);
			}),

			_addGrid: dojo.hitch(_this,function(){
				this.dataPres.getChartWidget().addPlot("back_grid", { type: "Grid", hMajorLines: true, vMajorLines: true, hAxis: "independent", vAxis: "dependent-primary" });
			}),

			_getZoomX: dojo.hitch(_this,function(){
				return this._zoomX;
			}),
			
			setPreparedStore:function(/*dojo.data.Read*/ store, /*Object*/ query, /*Object*/queryOptions){
				if(store){
					// cache store
					this.preparedstore = this.store = store;
					// fix labels on client to locale-specific format
					// OK to do on the client
					store.series_data[0] = dojo.map(store.series_data[0],function(longDate){
						var date = new Date(Number(longDate));
						var string = dojo.date.locale.format(date);
						return string;
					});
				}
				store = store || this.preparedstore;
				if(store){
					// compute the zoomed labelMod
					this.labelMod = 1;
					/*BEGIN DATAPRES COMPUTATION*/
					// modify to multiply by zoom factor
					var cwid = this.chartNode.offsetWidth*this._getZoomX()*2;
					var range = store.series_data;
					var tmp = ("" + range[0]).length * range.length * 7; // *assume* 7 pixels width per character ( was 9 )
					for(var z = 1; z < 500; ++z){
						if((tmp / z) < cwid){
							break;
						}
						++this.labelMod;
					}
				}
				this.inherited(arguments);
			},

			renderChartWidget: function(){
				this._updateMarkers();
				this._updateAxis();
				this._addGrid();
				// code from Dave Clark to get rid of markers and shadows
				var c2d = this.chartWidget;
				if (c2d) {
					c2d.stack[c2d.plots["primary-Lines"]].opt.markers = false;        // [A]
				}
				this.inherited(arguments);
			}
		});
		this.dataPres = new myDataPres(
			this.chartNode,
			{ legendVertical: true, legendNode: this.legendNode, gridNode: this.gridNode }
		);
		this._setTimeRangeAttr(dijit.byId(this.timeRangeNode).value);
	},

	startup: function(){
		// summary:
		//		Over-ride of startup behavior to select the right view
		//		if in A11Y mode.
		if(!this._started){
			if(this._isA11y()){
				// wait for renderGridWidget to be called the first time
				var c = dojo.connect(this.dataPres, "renderGridWidget", dojo.hitch(this, function(){
					// On initial render and in A11Y mode, swap view after chart rendered."
					dojo.disconnect(c);
					setTimeout(dojo.hitch(this, function(){
						this._accordion.selectChild(this._gridView); // select the Grid view
					}), 500); // delay since the chart needs time to render or else things lock up
				}));
			}
		}
		this.inherited(arguments);
	}
});	

// the following is the fix to dojo ticket #10958 needed only until dojo is updated
dojo.extend(dijit.form._FormValueWidget,
{
	_layoutHackIE7: function(){
		// summary:
		//		Work around table sizing bugs on IE7 by forcing redraw

		if(dojo.isIE == 7){ // fix IE7 layout bug when the widget is scrolled out of sight
			var domNode = this.domNode;
			var parent = domNode.parentNode;
			var pingNode = domNode.firstChild || domNode; // target node most unlikely to have a custom filter
			var origFilter = pingNode.style.filter; // save custom filter, most likely nothing
			var _this = this;
			while(parent && parent.clientHeight == 0){ // search for parents that haven't rendered yet
				(function ping(){
					var disconnectHandle = _this.connect(parent, "onscroll",
						function(e){
							_this.disconnect(disconnectHandle); // only call once
							pingNode.style.filter = (new Date()).getMilliseconds(); // set to anything that's unique
							setTimeout(function(){ pingNode.style.filter = origFilter }, 0); // restore custom filter, if any
						}
					);
				})();
				parent = parent.parentNode;
			}
		}
	}
});
