/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("xsa.messagecenter.MessageToaster");

dojo.require("idx.oneui.messaging.Toaster");
dojo.require("dojo.date");
dojo.require("dojo.date.locale");
dojo.requireLocalization("xsa.messagecenter", "xsa_messages");

dojo.declare("xsa.messagecenter.MessageToaster", [idx.oneui.messaging.Toaster],{

	_subscribeHandle: null,
	
	messageTimeout: 10000,
	
    constructor: function () {
	    this.inherited(arguments);
		this.xsa_messages = dojo.i18n.getLocalization("xsa.messagecenter", "xsa_messages");
		this._subscribeHandle = dojo.subscribe("NewToasterMessage", dojo.hitch(this, this.addNewMessage));
	    this.checkForMessages();
	},
	
	addNewMessage: function(data) {
		var content = new String(data.content);
		if(content.length>360){
			content = content.substring(0, 359) + " <b>. . .</b>";
		}
		content = content + "<br><br><a href='/dashboard/monitor/message_center/'>"+this.xsa_messages.openMessageCenter+"</a>";
		this.add({
			content: content,
			type: data.type,
			timestamp: dojo.date.locale.format(new Date(data.timestamp), {selector: "time", formatLength: "short"})
		});
		dojo.addClass(this.messageList, "break-word");
	},
	
	checkForMessages: function() {
		dojo.xhrGet({ 
			url: "/resources/message_center", 
			content: {action: "getMessageInfo"},
  			handleAs: "json",
            handle: dojo.hitch(this, function (data, args) { 
		/*For testing only	
			dojo.publish("NewToasterMessage", [{
				content: "This is a tests error with a lot of data...aksjdflkjaslkdjflaksjdf asdkjfskdjf more and more and more .. aslkdjflaksjdljfsd I am going to make this message extremely long.  So GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG I have to keep adding information to the end of the message.  lkajsdlfffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffa sdkjflasjdfla  blah aba This is a tests error with a lot of data...aksjdflkjaslkdjflaksjdf asdkjfskdjf more and more and more .. aslkdjflaksjdljfsd I am going to make this message extremely long.  So I have to keep adding information to the end of the message. This is a tests error with a lot of data...aksjdflkjaslkdjflaksjdf asdkjfskdjf more and more and more .. aslkdjflaksjdljfsd I am going to make this message extremely long.  So I have to keep adding information to the end of the message. ",
				type: "SEVERE",
				timestamp: 1337351656168
			}]);
		*/
                //Popup any new messages
				if(data.content) {
					dojo.publish("NewToasterMessage", [data]);
				}
				if(data.totalNumberOfMessages){
					dojo.publish("TotalMessages", [data]);
				}
                setTimeout(dojo.hitch(this, this.checkForMessages), 30000);
            })
		});
	},
	
	destroy: function(){
		if(this._subscribeHandle) dojo.unsubscribe(this._subscribeHandle);
		this.inherited(arguments);
	}
});